[ VIGRA Homepage | Function Index | Class Index | Namespaces | File List | Main Page ]

| FindAverage [Functors To Inspect Images] |

Find the average pixel value in an image or ROI. More...

`#include <vigra/inspectimage.hxx>`

List of all members.

## Public Types
typedef VALUETYPE | argument_type
typedef VALUETYPE | first_argument_type
typedef NumericTraits < VALUETYPE >::RealPromote | result_type
typedef double | second_argument_type
typedef NumericTraits < VALUETYPE >::RealPromote | value_type
## Public Member Functions
result_type | average () const
double | count () const
| FindAverage ()
result_type | operator() () const
void | operator() (FindAverage const &v)
void | operator() (first_argument_type const &v, second_argument_type weight)
void | operator() (argument_type const &v)
void | reset ()

## Detailed Description

### template<class VALUETYPE>
class vigra::FindAverage< VALUETYPE >

Find the average pixel value in an image or ROI.

In addition the size of the ROI is calculated. This Functor can also be used in conjunction with ArrayOfRegionStatistics to find the average of all regions in a labeled image.

Traits defined:

`FunctorTraits::isUnaryAnalyser` and `FunctorTraits::isInitializer` are true (`VigraTrueType`)

Usage:

#include <vigra/inspectimage.hxx>
Namespace: vigra

        vigra::BImage img;

        vigra::FindAverage<vigra::BImage::PixelType> average;   // init functor

        vigra::inspectImage(srcImageRange(img), average);

        cout << "Average: " << average();

Required Interface:

        VALUETYPE v1, v2(v1);
        double d;

        v1 += v2;
        v1 / d;

## Member Typedef Documentation

typedef VALUETYPE argument_type

the functor's argument type

typedef VALUETYPE first_argument_type

the functor's first argument type (for calls with a weight)

typedef NumericTraits<VALUETYPE>::RealPromote result_type

the functor's result type

typedef double second_argument_type

the functor's second argument type (for calls with a weight)

typedef NumericTraits<VALUETYPE>::RealPromote value_type

Deprecated:
  use argument_type and result_type

## Constructor & Destructor Documentation

FindAverage | ( |  | ) |

init average

## Member Function Documentation

result_type average | ( |  | ) | const

return current average

double count | ( |  | ) | const

return number of values (sum of weights) seen so far

result_type operator() | ( |  | ) | const

return current average

void operator() | ( | FindAverage< VALUETYPE > const & | v | ) |

merge two statistics

void operator() | ( | first_argument_type const & | v,
|  | second_argument_type | weight |
| ) |  |  |

update average, using weighted input. `stats(value, 1.0)` is equivalent to the unweighted call `stats(value)`, and `stats(value, 2.0)` is equivalent to two unweighted calls.

void operator() | ( | argument_type const & | v | ) |

update average

void reset | ( |  | ) |

(re-)init average

The documentation for this class was generated from the following file:

- vigra/inspectimage.hxx

© Ullrich Köthe (ullrich.koethe@iwr.uni-heidelberg.de) Heidelberg Collaboratory for Image Processing, University of Heidelberg, Germany | html generated using doxygen and Python vigra 1.7.1 (3 Dec 2010)